Subject: Re: [PROBLEM] WARNING: at kernel/exit.c:910 do_exit

From: Oleg Nesterov <[email-masked]>
Date: Sun, 21 Nov 2010 19:51:16 +0100

On 11/21, Linus Torvalds wrote:
>
> On Sun, Nov 21, 2010 at 7:35 AM, Pekka Enberg <[email-masked]> wrote:
> >
> >        WARN_ON(atomic_read(&tsk->fs_excl));
> >
> > in do_exit(). There was a prior oops in __pipe_free_info() called in
> > sys_recvmsg() paths that unfortunately scrolled away.
>
> That WARN_ON() is almost certainly due to the previous oops.
>
> The previous oops may have scrolled away, but you can see the
> call-chain, since it's part of the later oops. Except the photo is
> hard to read ;)
>
> In fact, you can see that there has been _two_ oopses before that. The
> "free_pipe_info()" oops comes from the "do_exit()" path of the _first_
> oops.
>
> So the original oops seems to be around here:
>
>    (*probably* oopsed in __scm_destroy)
>    (the fd_install on the stack is likely from scm_detach_fds calling
> it before calling __scm_destroy - just a stale pointer remaining on
> the stack)
>    scm_detach_fds
>    unix_stream_recvmsg
>    sock_recvmsg
>    __sys_recvmsg
>    sys_recvmsg

Yes, but still I am puzzled a bit. Where ->fs_excl != 0 comes from?
Not that I really understand what it means, but nothing in this path
can do lock_super(), I think. This means it was already nonzero or
the bug caused the memory corruption.

Btw, why it is atomic_t ?

> And who knows? It may be that the networking oops was due to some
> other earlier problem that isn't part of this particular callchain and
> that has long since scrolled away.

Agreed, probably this is false alarm. The oopsing task can trigger
a lot of "wrong" warnings.

Oleg.